/*****************************************************************************/
/*                                                                           */
/* Copyright (c) 1989-2001 Morgan Stanley Dean Witter & Co. All rights reserved.*/
/* See .../src/LICENSE for terms of distribution.                           */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
#if defined(_AIX)

extern int cs();

tas(i)
  int *i;
{
  return (cs(i, 0, 1));
}

#elif defined(lint)

int 
tas(cp)
  char *cp;
{
  return (int) (*cp);
}

#else

/* the function is defined in tas_asm.s */

#endif

#ifdef UNITTEST
/* unit test header file inclusions */
#include <stdio.h>
#include <dap/dap.h>

/* unit test function declarations */
extern int main();

/* unit test function definitions */
int 
main()
{
  char c = 0;

  if (tas(&c))
    (void) fprintf(stdout, "failed 1\n");
  if (!tas(&c))
    (void) fprintf(stdout, "failed 2\n");

  c = 0;

  if (tas(&c))
    (void) fprintf(stdout, "failed 3\n");

  exit(0);
}
#endif
